<?php

namespace App\Classes\Modules\Accounting\DataTransferObjects;

use App\Classes\General\Interfaces\DataTransferObject;
use App\Classes\ValueObjects\Constants\ApprovalStatus;
use PhpOffice\PhpSpreadsheet\Calculation\Logical\Boolean;

class BankStatementTransactionObject implements DataTransferObject
{
    /** @var int */
    private $statement_transaction_id;

    /** @var int */
    private $type;

    /** @var string */
    private $system;

    /** @var string */
    private $owner_type;

    /** @var int */
    private $owner_id;

    /** @var string */
    private $invoice_reference;

    /** @var string */
    private $receipt_reference;

    /** @var Boolean */
    private $is_auto_mapped;

    /** @var int|null */
    private $status;

    /**
     * BankStatementDetailObject constructor.
     * @param string $pay_for
     * @param string $system_references
     * @param int|null $type
     */
    public function __construct(
        $statement_transaction_id,
        $type,
        $system,
        $owner_type,
        $owner_id,
        $invoice_reference,
        $receipt_reference,
        $is_auto_mapped,
        ?int $status = ApprovalStatus::PENDING_VERIFICATION
    ) {
        $this->statement_transaction_id = $statement_transaction_id;
        $this->type = $type;
        $this->system = $system;
        $this->owner_type = $owner_type;
        $this->owner_id = $owner_id;
        $this->invoice_reference = $invoice_reference;
        $this->receipt_reference = $receipt_reference;
        $this->is_auto_mapped = $is_auto_mapped;
        $this->status = $status;
    }

    /**
     * @return int
     */
    public function getStatementTransactionId(): int
    {
        return $this->statement_transaction_id;
    }

    /**
     * @return int
     */
    public function getType(): int
    {
        return $this->type;
    }

    /**
     * @return string
     */
    public function getOwnerType(): string
    {
        return $this->owner_type;
    }

    /**
     * @return int
     */
    public function getOwnerId(): int
    {
        return $this->owner_id;
    }
    
    /**
     * @return string
     */
    public function getSystem(): string
    {
        return $this->system;
    }

    /**
     * @return string
     */
    public function getInvoiceReference(): string
    {
        return $this->invoice_reference;
    }

    /**
     * @return string
     */
    public function getReceipteReference(): string
    {
        return $this->receipt_reference;
    }

    /**
     * @return Boolean
     */
    public function getIsAutoMapped(): Boolean
    {
        return $this->is_auto_mapped;
    }

    /**
     * @return int
     */
    public function getStatus(): int
    {
        return $this->status;
    }
}
